<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);

//Import the braintree library
require_once 'braintree-php-4.1.0/lib/Braintree.php';

//Set up the gateway using merchant credentials
$gateway = new Braintree_Gateway([
		'environment' => 'sandbox',
		'merchantId' => '4kqzx9mqxbck8647',
		'publicKey' => 'byd22sz9t4jhzzrq',
		'privateKey' => 'cf035245a01dd564c1dac02f505e2ae6'
]);

//Get the nonce from the POST
$nonceFromTheClient = $_POST["payment_method_nonce"];


/* Simple Transaction */

// $result = $gateway->transaction()->sale([
// 		'amount' => '10.00',
// 		'paymentMethodNonce' => $nonceFromTheClient,
// 		'options' => [
// 				'submitForSettlement' => True
// 		]
// ]);



/* Simple customer creation */ 

// $result = $gateway->customer()->create([
// 		'firstName' => 'Mike',
// 		'lastName' => 'Jones',
// 		'company' => 'Jones Co.',
// 		'email' => 'mike.jones@example.com',
// 		'phone' => '281.330.8004',
// 		'fax' => '419.555.1235',
// 		'website' => 'http://example.com'
// ]);




/* Transaction and customer creation */

$result = $gateway->transaction()->sale([
		'amount' => '10.00',
		'paymentMethodNonce' => $nonceFromTheClient,
		'customer' => [
				'firstName' => 'Niall',
				'lastName' => 'Mulready',
				'company' => 'Beardyman Whiskey',
				'phone' => '0771234567',
				'fax' => '0771234567',
				'website' => 'http://www.bmw.com',
				'email' => 'Niall@bmw.com'
		],
		'billing' => [
				'firstName' => 'Niall',
				'lastName' => 'Mulready',
				'company' => 'Beardyman Whiskey',
				'streetAddress' => '10 Downing Street',
				'extendedAddress' => 'Westminster',
				'locality' => 'London',
				'region' => 'GB',
				'postalCode' => 'SW1A 2AA',
				'countryCodeAlpha2' => 'GB'
		],
		'shipping' => [
				'firstName' => 'Niall',
				'lastName' => 'Mulready',
				'company' => 'Beardyman Whiskey',
				'streetAddress' => '10 Downing Street',
				'extendedAddress' => 'Westminster',
				'locality' => 'London',
				'region' => 'GB',
				'postalCode' => 'SW1A 2AA',
				'countryCodeAlpha2' => 'GB'
		],
		'customer' => [
				'id' => 'customer_id3'
		],
		'options' => [
				'storeInVaultOnSuccess' => true,
				'submitForSettlement' => true
		]
]);

//Verify that the payment was successful
if ($result->success) 
{
	//Optimal refund example
	$result = $gateway->transaction()->refund($result->transaction->id, '5.00');
	
	//Other example methods
	
// 	$result->success
// 	# true
// 	$result->transaction->type
// 	# 'credit'
// 	$result->transaction->amount
// 	# "50.00"
	
// 	$result = $gateway->transaction()->refund('a_transaction_id', '10.00');
// 	$result->success
// 	# true
// 	$result->transaction->type
// 	# 'credit'
// 	$result->transaction->amount
// 	# "10.00"

	//Check if refund was successful
	if ($result->success) 
	{
		print_r("Success ID: " . $result->transaction->id);
	}
	else 
	{
		print_r("Error Message: " . $result->message);
	}
	
	
} 
else 
{
	print_r("Error Message: " . $result->message);
}



